"""Code generated by Speakeasy (https://speakeasyapi.dev). DO NOT EDIT."""

from __future__ import annotations
import dataclasses
import requests as requests_http
from dataclasses_json import Undefined, dataclass_json
from sdk import utils
from typing import Optional


@dataclasses.dataclass
class GetPublicTotalViewsMetricsRequest:
    playback_id: str = dataclasses.field(metadata={'path_param': { 'field_name': 'playbackId', 'style': 'simple', 'explode': False }})
    r"""The playback ID to filter the query results. This can be a canonical
    playback ID from Livepeer assets or streams, or dStorage identifiers
    for assets
    """
    



@dataclass_json(undefined=Undefined.EXCLUDE)
@dataclasses.dataclass
class GetPublicTotalViewsMetricsData:
    r"""A simplified metric object about aggregate viewership of an
    asset. Either playbackId or dStorageUrl will be set.
    """
    playtime_mins: float = dataclasses.field(metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('playtimeMins') }})
    r"""The total playtime in minutes for the asset"""
    view_count: int = dataclasses.field(metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('viewCount') }})
    r"""The number of views for the asset"""
    d_storage_url: Optional[str] = dataclasses.field(default=None, metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('dStorageUrl'), 'exclude': lambda f: f is None }})
    r"""The URL of the distributed storage used for the asset"""
    playback_id: Optional[str] = dataclasses.field(default=None, metadata={'dataclasses_json': { 'letter_case': utils.get_field_name('playbackId'), 'exclude': lambda f: f is None }})
    r"""The playback ID associated with the metric"""
    



@dataclasses.dataclass
class GetPublicTotalViewsMetricsResponse:
    content_type: str = dataclasses.field()
    r"""HTTP response content type for this operation"""
    status_code: int = dataclasses.field()
    r"""HTTP response status code for this operation"""
    data: Optional[GetPublicTotalViewsMetricsData] = dataclasses.field(default=None)
    r"""A single Metric object with the viewCount and playtimeMins metrics."""
    raw_response: Optional[requests_http.Response] = dataclasses.field(default=None)
    r"""Raw HTTP response; suitable for custom response parsing"""
    

